aniwrapper/ani-cli

989 lines
27 KiB
Plaintext
Raw Normal View History

#!/usr/bin/env bash
2021-06-09 05:25:23 -07:00
VERBOSE=0
2022-01-02 23:18:27 -08:00
BASE_URL=$(curl -s -L -o /dev/null -w "%{url_effective}\n" https://gogoanime.cm)
CFG_DIR="${XDG_CONFIG_HOME:-$HOME/.config}/aniwrapper"
HISTORY_DB="$CFG_DIR/history.sqlite3"
ANIWRAPPER_ICON_PATH="$CFG_DIR/icons/icon-64.png"
MAISAN_ICON_PATH="$CFG_DIR/icons/MYsan.png"
ROFI_THEME="aniwrapper.rasi"
ROFI_CFG="$CFG_DIR/themes/$ROFI_THEME"
PLAYER_CMD="mpv"
2022-01-09 02:33:29 -08:00
THEMES="aniwrapper (default)|dracula|fancy|flamingo|material|nord|onedark"
# dependencies: grep, sed, curl, video_player, rofi, sqlite3
2021-06-13 04:54:19 -07:00
# video_player ( needs to be able to play urls )
player_fn="mpv"
2022-01-05 11:44:42 -08:00
playable="\.mp4|\.mkv|\.ts|\.mp3|\.webm"
2022-01-11 11:53:21 -08:00
playable_list="mp4,mkv,ts,mp3,webm"
2021-06-09 05:25:23 -07:00
prog="ani-cli"
2021-06-09 08:53:30 -07:00
c_red="\033[1;31m"
c_green="\033[1;32m"
c_yellow="\033[1;33m"
c_blue="\033[1;34m"
c_magenta="\033[1;35m"
c_cyan="\033[1;36m"
c_reset="\033[0m"
help_text() {
2021-11-25 10:52:59 -08:00
while IFS= read -r line; do
2021-06-09 05:25:23 -07:00
printf "%s\n" "$line"
2022-01-02 09:53:16 -08:00
done <<- EOF
USAGE: $prog <query>
-h show this help text
-d download episode
-H continue where you left off
2021-06-09 05:25:23 -07:00
EOF
}
die() {
2021-06-11 06:40:54 -07:00
printf "$c_red%s$c_reset\n" "$*" >&2
2021-06-09 05:25:23 -07:00
exit 1
}
err() {
printf "$c_red%s$c_reset\n" "$*" >&2
}
2022-01-07 09:24:13 -08:00
logger() {
# prints passed in args to stdout if $VERBOSE is set to 1
2021-11-18 15:52:37 -08:00
[ "$VERBOSE" -eq 1 ] && printf "%s\n" "$*" >&2
}
search_anime() {
2021-06-09 05:25:23 -07:00
# get anime name along with its id
2022-01-07 09:24:13 -08:00
logger "NUM ARGS: $#"
2022-01-02 09:53:16 -08:00
if [[ $# -gt 1 ]]; then
# if multi-word query, concatenate into one string and replace spaces with '-'
search="$*"
search="${search// /-}"
else
# if one word, remove leading or trailing whitespace
search="${1// /}"
fi
2022-01-07 09:24:13 -08:00
logger "Search Query: $search"
titlepattern='<a href="/category/'
2021-11-06 21:18:24 -07:00
curl -s "$BASE_URL//search.html" \
2021-06-09 05:25:23 -07:00
-G \
-d "keyword=$search" |
2022-01-02 09:53:16 -08:00
sed -n -E '
s_^[[:space:]]*<a href="/category/([^"]*)" title="([^"]*)".*_\1_p
'
2021-06-09 05:25:23 -07:00
}
search_eps() {
2021-06-09 05:25:23 -07:00
# get available episodes for anime_id
anime_id=$1
2021-11-06 21:18:24 -07:00
curl -s "$BASE_URL/category/$anime_id" |
2022-01-02 09:53:16 -08:00
sed -n -E '
2021-06-09 05:25:23 -07:00
/^[[:space:]]*<a href="#" class="active" ep_start/{
s/.* '\''([0-9]*)'\'' ep_end = '\''([0-9]*)'\''.*/\2/p
q
}
'
}
check_input() {
2022-01-07 09:24:13 -08:00
logger "Checking input"
logger "EP START: $ep_choice_start"
logger "EP END: $ep_choice_end"
2022-01-02 11:19:31 -08:00
[ "$ep_choice_start" -eq "$ep_choice_start" ] 2> /dev/null || die "Invalid number entered: $ep_choice_start"
episodes=$ep_choice_start
if [ -n "$ep_choice_end" ]; then
2022-01-02 11:19:31 -08:00
[ "$ep_choice_end" -eq "$ep_choice_end" ] 2> /dev/null || die "Invalid number entered: $ep_choice_end"
# create list of episodes to download/watch
episodes=$(seq $ep_choice_start $ep_choice_end)
fi
2021-10-07 03:21:38 -07:00
}
2022-01-03 22:12:24 -08:00
get_dpage_link() {
2021-12-10 23:15:40 -08:00
# get the download page url
anime_id=$1
ep_no=$2
2021-06-09 05:25:23 -07:00
2021-12-10 23:15:40 -08:00
# credits to fork: https://github.com/Dink4n/ani-cli for the fix
# dub prefix takes the value "-dub" when dub is needed else is empty
2022-01-03 22:12:24 -08:00
anime_page=$(curl -s "$BASE_URL/$anime_id${dub_prefix}-$ep_no")
if printf '%s' "$anime_page" | grep -q "404"; then
2022-01-03 22:12:24 -08:00
anime_page=$(curl -s "$BASE_URL/$anime_id${dub_prefix}-episode-$ep_no")
fi
2021-12-10 23:15:40 -08:00
2022-01-03 22:12:24 -08:00
printf '%s' "$anime_page" |
2022-01-07 09:24:13 -08:00
sed -n -E 's/.*rel="13" data-video="([^"]*)".*/\1/p' | cut -d/ -f5
}
2021-12-10 23:15:40 -08:00
get_video_quality() {
2022-01-03 22:12:24 -08:00
dpage_url=$1
2022-01-07 09:24:13 -08:00
video_links=$(curl -s "https://sbplay2.com/d/$dpage_url" | sed -n -E 's/.*a href="#" onclick="download_video([^"]*)".*/\1/p' | head -1)
logger "VIDEO LINKS: $video_links" 1> /dev/stderr
2022-01-05 10:54:19 -08:00
m=$(printf "%s" "$quality" | cut -c1)
h=$(printf "%s" "$video_links" | cut -d\' -f6)
2022-01-07 09:24:13 -08:00
logger "constructed video link -> https://sbplay2.com/dl?op=download_orig&id=$dpage_url&mode=$m&hash=$h" 1> /dev/stderr
video_link=$(curl -s "https://sbplay2.com/dl?op=download_orig&id=$dpage_url&mode=$m&hash=$h" | sed -n -E 's/<a href="([^"]*.mp4)".*/\1/p')
2022-01-05 10:54:19 -08:00
if [ -z "$video_link" ]; then
err "$quality quality doesn't exist, falling back to normal quality"
2022-01-07 09:24:13 -08:00
video_link=$(curl -s "https://sbplay2.com/dl?op=download_orig&id=$dpage_url&mode=n&hash=$h" | sed -n -E 's/<a href="([^"]*.mp4)".*/\1/p')
2022-01-05 10:54:19 -08:00
fi
2022-01-03 22:12:24 -08:00
printf '%s' "$video_link"
}
dep_ch() {
2021-06-11 06:18:20 -07:00
for dep; do
2022-01-02 09:53:16 -08:00
if ! command -v "$dep" > /dev/null; then
2021-06-11 06:18:20 -07:00
die "Program \"$dep\" not found. Please install it."
fi
done
}
run_stmt() {
printf "%s\n" "$1" | sqlite3 -noheader "$HISTORY_DB"
}
2022-01-08 14:55:17 -08:00
notification() {
msg="$*"
if command -v "notify-send" > /dev/null; then
notify-send -i "$ANIWRAPPER_ICON_PATH" "$msg"
else
logger "$msg"
fi
}
#####################
## Database Code ##
#####################
check_db() {
2022-01-02 09:53:16 -08:00
# Return number of matches for anime/episode in db
# args:
# $1: anime name: str
# $2: either 'search' or 'watch' for which db to query
2022-01-08 14:55:17 -08:00
# logger "BEGIN check_db()"
if [[ "$1" == "directory" ]]; then
stmt="SELECT DISTINCT COUNT(*) \
FROM file_history \
WHERE directory = '$2';"
elif [[ "$1" == "file" ]]; then
stmt="SELECT DISTINCT COUNT(*) \
FROM file_history \
WHERE directory = '$2' \
AND filename = '$3';"
elif [[ "$2" == "search" ]]; then
stmt="SELECT DISTINCT COUNT(*) \
FROM search_history \
WHERE anime_name = '$1';"
else
stmt="SELECT DISTINCT COUNT(*) \
FROM watch_history \
WHERE anime_name = '$1' \
2022-01-02 14:07:00 -08:00
AND episode_number = '$2';"
fi
res=$(run_stmt "$stmt")
return $res
2022-01-08 14:55:17 -08:00
# logger "END check_db... Result -> $res"
}
2022-01-07 10:50:52 -08:00
# return true (0) if $source_dt > $target_dt
check_date() {
source_dt="$1"
target_dt="$2"
2022-01-07 12:10:20 -08:00
if [[ "$source_dt" < "$target_dt" ]] || [[ "$source_dt" == "$target_dt" ]]; then
2022-01-07 10:50:52 -08:00
return 1
else
return 0
fi
}
2021-11-25 10:52:59 -08:00
# updates search/watch date for passed in anime
update_date() {
datetime=$(date +'%Y-%m-%d %H:%M:%S')
stmt=""
if [[ "$1" == "directory" ]]; then
logger "UPDATING FILE_HISTORY: directory='$2', filename='DIRECTORY', search_date='$datetime'"
stmt="UPDATE file_history SET watch_date = '$datetime' \
WHERE directory = '$2' and filename = '$3';"
elif [[ "$1" == "file" ]]; then
2022-01-07 09:24:13 -08:00
logger "UPDATING FILE_HISTORY: directory='$2', filename='$3', search_date='$datetime'"
stmt="UPDATE file_history SET watch_date = '$datetime' \
WHERE directory = '$2' and filename = '$3';"
elif [[ "$2" == "search" ]]; then
2022-01-07 09:24:13 -08:00
logger "UPDATING SEARCH_HISTORY: anime_name='$1', search_date='$datetime'"
stmt="UPDATE search_history SET search_date = '$datetime' \
WHERE anime_name = '$1';"
elif [[ $# -ge 3 ]]; then
2022-01-07 10:50:52 -08:00
temp_dt="${3// /:}"
[ -z "$temp_dt" ] && return 1
hist_dt=$(run_stmt "SELECT watch_date FROM watch_history WHERE anime_name='$1' AND episode_number='$2';")
hist_dt="${hist_dt// /:}"
logger "Checking if update is needed..."
if ! check_date "$hist_dt" "$temp_dt"; then
logger "Passed in date is older or same than current date... doing nothing"
return 1
fi
logger "UPDATING watch_history from sync. watch_date -> $temp_dt"
stmt="UPDATE watch_history SET watch_date = '$temp_dt' \
WHERE anime_name = '$1' \
AND episode_number = $2;"
else
2022-01-07 09:24:13 -08:00
logger "UPDATING WATCH_HISTORY: anime_name='$1', episode_number='$2' search_date='$datetime'"
stmt="UPDATE watch_history SET watch_date = '$datetime' \
WHERE anime_name = '$1' \
AND episode_number = $2;"
fi
run_stmt "$stmt"
}
insert_history() {
# inserts into search/watch history db
# check the anime_name/id
datetime=$(date +'%Y-%m-%d %H:%M:%S')
2022-01-08 14:55:17 -08:00
logger "Checking if ($*) exists in db"
check_db "$@"
2021-11-25 10:52:59 -08:00
res="$?"
if [[ $res -gt 0 ]]; then
2022-01-08 14:55:17 -08:00
logger "Match found... Updating row in history db..."
2022-01-11 11:53:21 -08:00
wait # in case there's another insert/update still running in background?
update_date "$@"
2022-01-07 10:50:52 -08:00
res=$?
else
2022-01-07 10:50:52 -08:00
logger "Row not found in DB... inserting"
if [[ "$1" == "directory" ]]; then
stmt="INSERT INTO file_history(directory, filename, watch_date) \
VALUES('$2', 'DIRECTORY', '$datetime');"
elif [[ "$1" == "file" ]]; then
stmt="INSERT INTO file_history(directory, filename, watch_date) \
VALUES('$2', '$3', '$datetime');"
elif [[ "$2" == "search" ]]; then
stmt="INSERT INTO search_history(anime_name, search_date) \
VALUES('$1', '$datetime');"
else
stmt="INSERT INTO \
watch_history(anime_name, episode_number, watch_date) \
VALUES('$1', '$2', '$datetime');"
fi
2022-01-07 10:50:52 -08:00
logger "INSERT STATEMENT -> $stmt"
2022-01-09 12:34:21 -08:00
wait # in case there's another insert/update still running in background
run_stmt "$stmt"
2022-01-07 10:50:52 -08:00
res=$?
fi
2022-01-07 10:50:52 -08:00
return $res
}
sync_search_history() {
cnt=0
2022-01-07 10:50:52 -08:00
errs=0
while read -r line; do
2022-01-02 09:53:16 -08:00
anime_name=$(awk -F '|' '{print $2}' <<< "$line")
2022-01-08 14:55:17 -08:00
logger "Checking if $anime_name has been searched..."
2022-01-02 09:53:16 -08:00
res=$(sqlite3 -noheader "$HISTORY_DB" "SELECT COUNT(*) FROM search_history WHERE anime_name = '$anime_name'")
if [[ "$res" -eq 0 ]]; then
2022-01-02 09:53:16 -08:00
search_date=$(awk -F '|' '{print $3}' <<< "$line")
2022-01-08 14:55:17 -08:00
logger "Not found in db... Adding ($anime_name|$search_date) to search history..."
if ! sqlite3 "$HISTORY_DB" "INSERT INTO search_history(anime_name, search_date) VALUES('$anime_name', '$search_date')"; then
2022-01-07 10:50:52 -08:00
((++errs))
continue
fi
((++cnt))
fi
2022-01-08 14:55:17 -08:00
logger
done <<< "$(sqlite3 -list -noheader "$temp_db" "SELECT DISTINCT * FROM search_history")"
logger "$cnt rows inserted into search_history table"
2022-01-07 10:50:52 -08:00
logger "$errs errors on insert"
}
sync_watch_history() {
cnt=0
2022-01-07 10:50:52 -08:00
errs=0
while read -r line; do
2021-11-18 15:52:37 -08:00
anime_name="${line/ //}"
2022-01-08 14:55:17 -08:00
# some spacing for log messages
logger && logger "ANIME: $anime_name"
episodes=$(sqlite3 -list -noheader "$temp_db" "SELECT episode_number, watch_date FROM watch_history WHERE anime_name = '$anime_name'")
2021-11-18 15:52:37 -08:00
# for each episode of $anime_name on the remote machine, check local
while read -r ep; do
2022-01-08 14:55:17 -08:00
logger
2022-01-02 09:53:16 -08:00
episode_num=$(awk -F '|' '{print $1}' <<< "$ep")
2022-01-07 10:50:52 -08:00
watch_date=$(awk -F '|' '{print $NF}' <<< "$ep")
if ! insert_history "$anime_name" "$episode_num" "$watch_date"; then
((++errs))
continue
fi
2022-01-07 10:50:52 -08:00
((++cnt))
2022-01-02 09:53:16 -08:00
done <<< "${episodes[@]}"
2022-01-08 14:55:17 -08:00
done <<< "$(sqlite3 -list -noheader "$temp_db" "SELECT DISTINCT anime_name FROM watch_history")"
logger "$cnt rows inserted into watch_history table"
logger "$errs rows skipped on insert"
}
#####################
### Play from file###
#####################
2022-01-05 10:54:19 -08:00
# opens the passed in file with $PLAYER_CMD
play_file() {
2022-01-07 09:24:13 -08:00
logger "Checking if file is playable"
if [[ "$1" =~ ($playable)$ ]]; then
2022-01-11 11:53:21 -08:00
filename="${1##*/}"
directory="${1%/*}"
insert_history "file" "$directory" "$filename" &
if [[ "$1" =~ .mp3 ]]; then
2022-01-07 09:24:13 -08:00
logger ".mp3 file found... playing without video"
2022-01-08 14:55:17 -08:00
notification "Playing $1"
$PLAYER_CMD --no-video "$1"
else
2022-01-08 14:55:17 -08:00
notification "Playing $1"
2022-01-09 02:33:29 -08:00
$PLAYER_CMD "$1" > /dev/null 2>&1 &
fi
2022-01-08 14:55:17 -08:00
return $?
else
die "File: $1 is not playable... Quitting"
fi
}
2022-01-09 02:33:29 -08:00
get_directory_data() {
search_dir="$1"
2022-01-09 02:33:29 -08:00
inputlist=""
watched=""
2022-01-09 02:33:29 -08:00
cnt=1
2022-01-11 11:53:21 -08:00
[ "$search_dir" = "/" ] && cnt=0 # account for no ../ on /
for directory in "$1"/*; do
directory="${directory##*/}"
[ -z "$inputlist" ] && inputlist="$directory" || inputlist="$inputlist|$directory"
if ! check_db "directory" "$search_dir/$directory"; then
2022-01-07 09:24:13 -08:00
logger "$search_dir/$directory opened before... adding $cnt to list" 1> /dev/stderr
2022-01-11 11:53:21 -08:00
[ -z "$watched" ] && watched="$cnt" || watched="$watched, $cnt"
fi
((++cnt))
2022-01-11 11:53:21 -08:00
done
# while read -r filename; do
shopt -s nullglob # set nullglob to avoid printing output if no files with extension exist
shopt -s nocaseglob # case insensitive globbing
for filename in "$1"/*."{$playable_list}"; do
[ -z "$inputlist" ] && inputlist="$filename" || inputlist="$inputlist|$filename"
if ! check_db "file" "$search_dir" "$filename"; then
2022-01-07 09:24:13 -08:00
logger "$filename watched before... adding $cnt to list" 1> /dev/stderr
2022-01-11 11:53:21 -08:00
[ -z "$watched" ] && watched="$cnt" || watched="$watched, $cnt"
fi
((++cnt))
2022-01-11 11:53:21 -08:00
done
shopt -u nullglob
shopt -u nocaseglob
2022-01-09 02:33:29 -08:00
[ "$search_dir" != "/" ] && inputlist="../|$inputlist|Back|Quit" || inputlist="$inputlist|Back|Quit"
logger "INPUT LIST: $inputlist" 1> /dev/stderr
2022-01-07 09:24:13 -08:00
logger "WATCHED LIST: $watched" 1> /dev/stderr
}
# recursive function for finding path to video file given a starting directory
find_media() {
inp="$1"
2022-01-08 14:55:17 -08:00
[ -z "$inp" ] && die "No directory"
# workaround to allow logging w/o affecting return output
2022-01-07 09:24:13 -08:00
logger "INPUT DIR: $inp" 1> /dev/stderr
# base case hit when a file is found
if [ -f "$inp" ]; then
printf "%s\n" "$inp"
return 0
fi
2022-01-09 02:33:29 -08:00
get_directory_data "$inp"
[ -z "$inputlist" ] && return 1
2022-01-08 14:55:17 -08:00
selection=$(rofi -dmenu -only-match -async-pre-read 33 -config "$ROFI_CFG" \
-l 15 -i -sep '|' -mesg "$(generate_span "Current directory: $inp")" -a "$watched" \
2022-01-09 02:33:29 -08:00
-p "Enter selection" <<< "$inputlist")
2022-01-08 14:55:17 -08:00
case "$selection" in
2022-01-09 02:33:29 -08:00
Back | ../)
2022-01-11 11:53:21 -08:00
dotdotslash="${inp%/*}"
[ -z "$dotdotslash" ] && find_media "/" || find_media "$dotdotslash"
2022-01-08 14:55:17 -08:00
;;
Quit)
return 1
;;
*)
if [ ! -d "$inp/$selection" ] && [ ! -f "$inp/$selection" ]; then
return 1
else
insert_history "directory" "$inp/$selection" &
2022-01-08 14:55:17 -08:00
if [ "$inp" = "/" ]; then
2022-01-11 11:53:21 -08:00
find_media "/$selection"
2022-01-08 14:55:17 -08:00
else
find_media "$inp/$selection"
fi
fi
;;
esac
}
# get query
get_search_query() {
# Get search history
stmt="SELECT DISTINCT id || '. ' || anime_name \
FROM search_history \
ORDER BY id DESC;"
hist=$(run_stmt "$stmt")
msg="Choose from list of searched anime below, or enter a unique name of an anime to search for"
span="<span foreground='peachpuff' style='italic' size='small' weight='light'>$msg</span>"
if [ -z "$*" ] && [ "$is_rofi" -eq 1 ]; then
query=$(rofi -dmenu -l 15 -p "Search Anime:" \
2022-01-02 09:53:16 -08:00
-mesg "$span" \
-config "$ROFI_CFG" <<< "${hist[@]}")
# Remove the id from the query
2021-11-13 01:39:54 -08:00
query="${query//[1-9]*\. /}"
2021-12-30 20:06:26 -08:00
# query="${query// /}"
2022-01-07 09:24:13 -08:00
logger "Query: $query"
2022-01-02 09:53:16 -08:00
elif [ "$is_rofi" -eq 0 ]; then
printf "Search Anime: "
read -r query
else
query=$*
fi
}
generate_span() {
msg="$*"
span="<span foreground='peachpuff' style='italic' size='small' weight='light'>$msg</span>"
printf "%s\n" "$span"
}
#####################
## Anime selection ##
#####################
2021-06-09 05:25:23 -07:00
anime_selection() {
# Select anime from query results
search_results=$*
if [ "$is_rofi" -eq 1 ]; then
count=1
menu=()
res=()
while read -r anime_id; do
menu+="$count. $anime_id\n"
idx=$((count - 1))
res["$idx"]="$anime_id"
count=$((count + 1))
2022-01-02 09:53:16 -08:00
done <<- EOF
$search_results
EOF
menu+="$count. Quit"
searched=""
cnt=0
# Get the comma separated list of indexes of anime that has been searched before
for anime in "${res[@]}"; do
2022-01-07 09:24:13 -08:00
logger "ANIME: $anime"
check_db "$anime" "search"
if [[ $? -gt 0 ]]; then
2022-01-08 14:55:17 -08:00
logger "$anime HAS BEEN SEARCHED BEFORE"
if [ -z "$searched" ]; then
searched="$cnt"
else
searched="$searched, $cnt"
fi
fi
2022-01-02 09:53:16 -08:00
((++cnt))
done
2022-01-07 09:24:13 -08:00
logger "SEARCHED: $searched"
# get the anime from indexed list
2022-01-08 14:55:17 -08:00
msg="<span foreground='peachpuff' style='italic' size='small' weight='normal'><b>Query: $query</b></span>"
user_input=$(printf "${menu[@]}" |
rofi -dmenu -config "$ROFI_CFG" \
-a "$searched" \
-l 12 -i -p "Enter selection:" \
2022-01-08 14:55:17 -08:00
-async-pre-read 33 \
2022-01-04 00:57:22 -08:00
-mesg "$msg" -only-match)
[ -z "$user_input" ] && return 1
if [ $(awk '{ print $NF }' <<< "$user_input") = "Quit" ]; then
2022-01-07 09:24:13 -08:00
logger "QUITTING"
return 1
fi
choice=$(printf '%s\n' "$user_input" | awk '{print $1}')
# Remove period after number
choice="${choice::-1}"
name=$(printf '%s\n' "$user_input" | awk '{print $NF}')
2022-01-02 09:53:16 -08:00
else
menu_format_string='[%d] %s\n'
menu_format_string_c1="$c_blue[$c_cyan%d$c_blue] $c_reset%s\n"
menu_format_string_c2="$c_blue[$c_cyan%d$c_blue] $c_yellow%s$c_reset\n"
count=1
while read anime_id; do
# alternating colors for menu
[ $((count % 2)) -eq 0 ] &&
menu_format_string=$menu_format_string_c1 ||
menu_format_string=$menu_format_string_c2
printf "$menu_format_string" "$count" "$anime_id"
count=$((count + 1))
done <<< "$search_results"
printf "$c_blue%s$c_green" "Enter number: "
read choice
printf "$c_reset"
name="$anime_id"
fi
2021-06-09 05:25:23 -07:00
2022-01-07 09:24:13 -08:00
logger "CHOICE: $choice"
2022-01-02 09:53:16 -08:00
if [ "$is_rofi" -eq 1 ]; then
# check both choice and name are set
if [[ ! "$choice" ]] || [[ ! "$name" ]]; then
die "Invalid choice... committing seppuku"
fi
fi
# Check if input is a number
[ "$choice" -eq "$choice" ] 2> /dev/null || die "Invalid number entered"
# Select respective anime_id
count=1
2021-11-25 10:52:59 -08:00
while read -r anime_id; do
if [ "$count" -eq "$choice" ]; then
selection_id=$anime_id
break
fi
count=$((count + 1))
2022-01-02 09:53:16 -08:00
done <<- EOF
$search_results
EOF
2022-01-02 09:53:16 -08:00
[ -z "$name" ] && name="$anime_id"
2022-01-05 10:54:19 -08:00
insert_history "$name" "search" &
printf "$c_reset"
[ -z "$selection_id" ] && die "Invalid number entered"
2022-01-02 09:53:16 -08:00
read -r last_ep_number <<- EOF
$(search_eps "$selection_id")
EOF
}
2021-06-09 05:25:23 -07:00
##################
## Ep selection ##
##################
episode_selection() {
ep_choice_start="1"
2022-01-02 09:53:16 -08:00
if [ "$is_rofi" -eq 1 ]; then
# select episode number for anime
2022-01-07 09:24:13 -08:00
logger "Anime ID: $anime_id"
2022-01-02 09:53:16 -08:00
stmt="SELECT DISTINCT episode_number \
FROM watch_history \
WHERE anime_name = '$anime_id';"
2022-01-02 09:53:16 -08:00
hist=$(run_stmt "$stmt")
2022-01-07 09:24:13 -08:00
# logger "HISTORY: ${hist[*]}"
2022-01-02 09:53:16 -08:00
# Get Watch History for $anime_id as comma separated list
watch_history=""
for i in $hist; do
if [[ "$watch_history" == "" ]]; then
watch_history="$((--i))"
else
watch_history="$watch_history, $((--i))"
fi
done
# get user choice and set the start and end
2022-01-08 14:55:17 -08:00
# msg='<span foreground="peachpuff" style="italic" size="small" weight="light"></span>'
msg=$(printf "%s\n%s\n" "$(generate_span "<b>Anime Name: $anime_id</b>")" "$(generate_span "Range of episodes can be provided as: START_EPISODE - END_EPISODE")")
2022-01-02 09:53:16 -08:00
choice=$(
seq 1 "$last_ep_number" |
rofi -dmenu -l 12 \
-a "$watch_history" \
-p "Select Episode [1, $last_ep_number]:" \
-mesg "$msg" \
-config "$ROFI_CFG"
2022-01-02 09:53:16 -08:00
)
ep_choice_start=$(printf '%s\n' "${choice}" | awk '{print $1}')
ep_choice_end=$(printf '%s\n' "${choice}" | awk '{print $NF}')
2022-01-07 09:24:13 -08:00
logger "START: $ep_choice_start | END: $ep_choice_end"
2022-01-02 09:53:16 -08:00
elif [ $last_ep_number -gt 1 ]; then
[ $is_download -eq 1 ] &&
printf "Range of episodes can be specified: start_number end_number\n"
printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " $last_ep_number
read ep_choice_start ep_choice_end
printf "$c_reset"
fi
2022-01-02 11:19:31 -08:00
# check for half episode
if [ "$(echo "$ep_choice_start" | awk '{ printf substr($0, 1, 1) }')" = "h" ]; then
2022-01-07 09:24:13 -08:00
logger "IS A HALF EPISODE"
2022-01-02 11:19:31 -08:00
half_ep=1
ep_choice_start=$(echo "$ep_choice_start" | awk '{ printf substr($0, 2) }')
ep_choice_end=$ep_choice_start
fi
if [[ -z "$ep_choice_start" ]] && [[ -z "$ep_choice_end" ]]; then
die "No episode range entered"
fi
# if only one episode was entered, set ep_choice_end to empty string so only selected episode plays
# otherwise plays from ep 1 - ep_choice_start
2021-11-01 19:48:19 -07:00
if [[ "$ep_choice_start" -eq "$ep_choice_end" ]]; then
ep_choice_end=""
fi
printf "$c_reset"
2021-06-09 05:25:23 -07:00
}
2021-06-09 05:25:23 -07:00
open_episode() {
anime_id=$1
episode=$2
ddir="$3"
2021-06-09 05:25:23 -07:00
if [ $half_ep -eq 1 ]; then
temp_ep=$episode
episode=$episode"-5"
fi
2022-01-07 09:24:13 -08:00
logger "Getting data for episode $episode"
2021-06-09 05:25:23 -07:00
# Don't update watch history if downloading episode
if [ "$is_download" -eq 0 ]; then
2022-01-05 10:54:19 -08:00
insert_history "$anime_id" "$episode" &
fi
2022-01-03 22:12:24 -08:00
dpage_link=$(get_dpage_link "$anime_id" "$episode")
2022-01-07 09:24:13 -08:00
video_url=$(get_video_quality "$dpage_link")
2022-01-05 10:54:19 -08:00
referer_link="https://sbplay2.com"
2021-06-09 05:25:23 -07:00
if [ $half_ep -eq 1 ]; then
episode=$temp_ep
half_ep=0
fi
2021-11-25 10:52:59 -08:00
if [ "$is_download" -eq 0 ]; then
kill "$PID" > /dev/null 2>&1
2022-01-07 09:24:13 -08:00
logger "PLAYING VIDEO: $video_url"
logger "REFERRER: $referer_link"
2022-01-05 10:54:19 -08:00
nohup "$player_fn" --http-header-fields="Referer:$referer_link" "$video_url" > /dev/null 2>&1 &
2022-01-03 22:12:24 -08:00
PID=$!
2022-01-08 14:55:17 -08:00
if command -v "notify-send" > /dev/null; then
notify-send -i "$ANIWRAPPER_ICON_PATH" "Playing $anime_id - Episode $episode"
else
printf "${c_green}\nVideo playing"
fi
2021-06-10 03:48:06 -07:00
else
2022-01-07 09:24:13 -08:00
logger "Downloading episode $episode ..."
logger "$video_url"
dl_dir="${ddir// /}/$anime_id"
# add 0 padding to the episode name
2021-11-25 10:52:59 -08:00
episode=$(printf "%03d" "$episode")
2021-06-10 03:48:06 -07:00
{
mkdir -p "$dl_dir" || die "Could not create directory"
2022-01-02 09:53:16 -08:00
if command -v "notify-send" > /dev/null; then
2022-01-05 10:54:19 -08:00
aria2c -x 16 -s 16 --referer="$referer_link" "$video_url" --dir="$dl_dir" -o "$episode.mp4" --download-result=hide &&
2022-01-02 09:53:16 -08:00
notify-send -i "$ANIWRAPPER_ICON_PATH" "Download complete for ${anime_id//-/ } - Episode: $episode" ||
notify-send -i "$MAISAN_ICON_PATH" "Download failed for ${anime_id//-/ } - Episode: $episode. Please retry or check your internet connection"
else
2022-01-05 10:54:19 -08:00
aria2c -x 16 -s 16 --referer="$referer_link" "$video_url" --dir="$dl_dir" -o "$episode.mp4" --download-result=hide &&
2022-01-02 09:53:16 -08:00
printf "${c_green}Downloaded complete for %s - Episode: %s${c_reset}\n" "${anime_id//-/ }" "$episode" ||
printf "${c_red}Download failed for %s - Episode: %s, please retry or check your internet connection${c_reset}\n" "${anime_id//-/ }" "$episode"
2022-01-08 14:55:17 -08:00
fi
2021-06-10 03:48:06 -07:00
}
fi
}
stream() {
2022-01-07 09:24:13 -08:00
logger "Running stream()"
logger "args: $*"
get_search_query "$*"
searched=0
if [ $# -le 1 ]; then
# check if anime has been searched before
anime_id="${query// /}"
2022-01-07 09:24:13 -08:00
[ -z "$anime_id" ] && die "No anime selected or queried"
logger "Checking if anime: $anime_id has been searched before..."
check_db "$anime_id" "search"
searched="$?"
2022-01-07 09:24:13 -08:00
logger "Searched before: $searched"
fi
if [ "$searched" -eq 0 ]; then
search_results=$(search_anime $query)
[ -z "$search_results" ] && die "No search results found"
2022-01-07 09:24:13 -08:00
logger "SEARCH RESULTS: $search_results"
if ! anime_selection "$search_results"; then
die "No anime selection found"
fi
else
# if the query is a previous search
# skip search_anime function and assign $query
anime_id="${query// /}"
selection_id="$anime_id"
2022-01-05 10:54:19 -08:00
insert_history "$anime_id" "search" &
read -r last_ep_number <<< "$(search_eps "$selection_id")"
fi
episode_selection
}
############
# Start Up #
############
2021-06-21 09:23:15 -07:00
# to clear the colors when exited using SIGINT
trap "printf '$c_reset'" INT HUP
# option parsing
scrape=query
2022-01-05 10:54:19 -08:00
quality=normal
is_rofi=1
is_download=0
download_dir="."
half_ep=0
while getopts 'hd:Hsvq:c-:f:t:T:CQ:' OPT; do
case "$OPT" in
2022-01-02 09:53:16 -08:00
h)
help_text
exit 0
;;
d)
is_download=1
download_dir="$OPTARG"
2022-01-07 09:24:13 -08:00
logger "DOWNLOAD DIR: $download_dir"
2022-01-02 09:53:16 -08:00
;;
H)
scrape=history
;;
s)
scrape=sync
;;
v)
VERBOSE=1
;;
q)
quality="$OPTARG"
2022-01-07 09:24:13 -08:00
logger "passed in quality: $quality"
2022-01-02 09:53:16 -08:00
;;
c)
is_rofi=0
;;
-)
case $OPTARG in
dub)
dub_prefix="-dub"
;;
*)
help_text
exit 1
;;
esac
;;
f)
scrape="file"
play_dir="$OPTARG"
2022-01-09 02:33:29 -08:00
[ "$play_dir" != "/" ] && play_dir="$(sed -E 's/\/$//' <<< "$play_dir")" # remove trailing slash... unless searching / for some reason
;;
t)
theme="$OPTARG"
case "$theme" in
aniwrapper)
ROFI_THEME=aniwrapper.rasi
;;
default)
ROFI_THEME=aniwrapper.rasi
;;
dracula)
ROFI_THEME=aniwrapper-dracula.rasi
;;
fancy)
ROFI_THEME=aniwrapper-fancy.rasi
;;
flamingo)
ROFI_THEME=aniwrapper-flamingo.rasi
;;
material)
ROFI_THEME=aniwrapper-material.rasi
;;
2022-01-09 02:33:29 -08:00
nord)
ROFI_THEME=aniwrapper-nord.rasi
;;
onedark)
ROFI_THEME=aniwrapper-onedark.rasi
;;
*)
die "$theme not a valid theme file. Themes: [$THEMES]"
;;
esac
2022-01-07 09:24:13 -08:00
logger "Setting theme for ani-cli -> $ROFI_THEME"
ROFI_CFG="$CFG_DIR/themes/$ROFI_THEME"
2022-01-07 09:24:13 -08:00
logger "ROFI_CFG: $ROFI_CFG"
;;
T)
ROFI_CFG="$OPTARG"
[ ! -f "$ROFI_CFG" ] && die "$ROFI_CFG does not exist"
2022-01-07 09:24:13 -08:00
logger "CUSTOM ROFI_CFG: $ROFI_CFG"
;;
C)
logger "Connecting to history database -> $CFG_DIR/history.sqlite3"
sqlite3 "$CFG_DIR/history.sqlite3"
exit $?
;;
Q)
query="$OPTARG"
logger "DATABASE QUERY: $query"
sqlite3 -line "$CFG_DIR/history.sqlite3" "$query"
exit $?
;;
2022-01-02 09:53:16 -08:00
*)
printf "%s\n" "Invalid option"
exit 1
;;
esac
done
shift $((OPTIND - 1))
dep_ch "$player_fn" "curl" "sed" "grep" "sqlite3" "rofi" "git" "aria2c"
########
# main #
########
case $scrape in
2022-01-02 09:53:16 -08:00
query)
stream "$*"
2022-01-02 09:53:16 -08:00
;;
history)
stmt="SELECT DISTINCT anime_name FROM watch_history ORDER BY watch_date DESC"
search_results=$(printf "%s\n" "$stmt" | sqlite3 -noheader "$HISTORY_DB")
[ -z "$search_results" ] && die "History is empty"
if ! anime_selection "${search_results[@]}"; then
die "No anime selection found"
fi
2022-01-07 09:24:13 -08:00
logger "SELECTION: $selection_id"
2022-01-02 09:53:16 -08:00
stmt="SELECT episode_number \
FROM watch_history \
WHERE anime_name = '$selection_id' \
ORDER BY watch_date DESC \
LIMIT 1"
2022-01-02 09:53:16 -08:00
ep_choice_start=$(run_stmt "$stmt")
2022-01-07 09:24:13 -08:00
logger "Most recently watched episode: $ep_choice_start"
2022-01-02 09:53:16 -08:00
;;
sync)
printf "%s" "Enter username for remote user: "
read -r username
printf "%s" "Enter host for remote user: "
read -r host
connection_str="$username@$host"
printf "%s" "Enter port to connect to remote host with or leave blank for default (22): "
read -r port
if [[ "${port/ //}" == "" ]]; then
PORT=22
else
PORT="$port"
fi
2022-01-02 09:53:16 -08:00
printf "%s" "Enter path to private key (leave blank if unsure or not needed): "
read -r key_path
2022-01-02 09:53:16 -08:00
printf "%s\n" "Syncing database with: $connection_str on port $PORT"
temp_db="/tmp/aniwrapper_tmp_history.sqlite3"
2022-01-02 09:53:16 -08:00
if [[ -z "$key_path" ]]; then
2022-01-02 23:18:27 -08:00
scp -P "$PORT" "$connection_str:$HISTORY_DB" "$temp_db"
2022-01-02 09:53:16 -08:00
else
2022-01-02 23:18:27 -08:00
scp -P "$PORT" -i "$key_path" "$connection_str:$HISTORY_DB" "$temp_db"
2022-01-02 09:53:16 -08:00
fi
if [[ "$?" -ne 0 ]]; then
die "Error getting database file from remote host"
fi
sync_search_history && sync_watch_history
exit $?
2022-01-02 09:53:16 -08:00
;;
file)
2022-01-07 09:24:13 -08:00
logger "STARTING DIR: $play_dir"
[ ! -d "$play_dir" ] && die "$play_dir does not exist"
insert_history "directory" "$play_dir" &
2022-01-08 14:55:17 -08:00
video_path=$(find_media "$play_dir")
retcode="$?"
if [ "$retcode" -ne 0 ]; then
die "QUITTING"
elif [ -z "$video_path" ]; then
die "Something went wrong getting path... path is empty"
fi
2022-01-08 14:55:17 -08:00
logger "VIDEO PATH: $video_path"
play_file "$video_path"
exit $?
;;
esac
2022-01-02 11:19:31 -08:00
check_input
# plays selected episode(s)
for ep in $episodes; do
open_episode "$selection_id" "$ep" "$download_dir"
2021-06-13 04:54:19 -07:00
done
if [[ "$is_download" -eq 1 ]]; then
2022-01-07 09:24:13 -08:00
logger "Finished downloading episodes: $episodes for $selection_id... exiting"
exit 0
fi
2021-06-13 04:54:19 -07:00
episode=${ep_choice_end:-$ep_choice_start}
choice=''
while :; do
2021-06-13 04:54:19 -07:00
printf "\n${c_green}Currently playing %s episode ${c_cyan}%d/%d\n" "$selection_id" $episode $last_ep_number
if [ "$episode" -ne "$last_ep_number" ]; then
printf "$c_blue[${c_cyan}%s$c_blue] $c_yellow%s$c_reset\n" "n" "next episode"
fi
if [ "$episode" -ne "1" ]; then
printf "$c_blue[${c_cyan}%s$c_blue] $c_magenta%s$c_reset\n" "p" "previous episode"
fi
if [ "$last_ep_number" -ne "1" ]; then
printf "$c_blue[${c_cyan}%s$c_blue] $c_yellow%s$c_reset\n" "s" "select episode"
fi
2021-10-07 03:24:15 -07:00
printf "$c_blue[${c_cyan}%s$c_blue] $c_magenta%s$c_reset\n" "r" "replay current episode"
printf "$c_blue[${c_cyan}%s$c_blue] $c_yellow%s$c_reset\n" "a" "search for another anime"
# printf "$c_blue[${c_cyan}%s$c_blue] $c_magenta%s$c_reset\n" "h" "search history"
2021-06-09 08:53:30 -07:00
printf "$c_blue[${c_cyan}%s$c_blue] $c_red%s$c_reset\n" "q" "exit"
2021-06-09 14:49:28 -07:00
printf "${c_blue}Enter choice:${c_green} "
2021-11-25 10:52:59 -08:00
read -r choice
2021-06-09 08:53:30 -07:00
printf "$c_reset"
2021-06-09 05:25:23 -07:00
case $choice in
2022-01-02 09:53:16 -08:00
n)
episode=$((episode + 1))
;;
p)
episode=$((episode - 1))
;;
s)
printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " "$last_ep_number"
read -r episode
if [ "$(echo "$episode" | cut -c1-1)" = "h" ]; then
half_ep=1
episode=$(echo "$episode" | cut -c2-)
fi
2022-01-02 09:53:16 -08:00
printf "$c_reset"
[ "$episode" -eq "$episode" ] 2> /dev/null || die "Invalid number entered"
;;
r)
episode=$((episode))
;;
a)
stream
episode=$ep_choice_start
2022-01-07 09:24:13 -08:00
logger "NEW EPISODE: $selection_id - $episode"
;;
2022-01-02 09:53:16 -08:00
q)
break
;;
2021-11-29 13:08:41 -08:00
2022-01-02 09:53:16 -08:00
*)
die "invalid choice"
;;
esac
open_episode "$selection_id" "$episode" "$download_dir"
2021-06-09 05:25:23 -07:00
done